# coding: utf-8

"""
    Gate API v4

    Welcome to Gate.io API  APIv4 provides spot, margin and futures trading operations. There are public APIs to retrieve the real-time market statistics, and private APIs which needs authentication to trade on user's behalf.  # noqa: E501

    Contact: support@mail.gate.io
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from gate_api.configuration import Configuration


class CollateralAdjustRes(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'order_id': 'int',
        'collateral_currencies': 'list[CollateralCurrencyRes]'
    }

    attribute_map = {
        'order_id': 'order_id',
        'collateral_currencies': 'collateral_currencies'
    }

    def __init__(self, order_id=None, collateral_currencies=None, local_vars_configuration=None):  # noqa: E501
        # type: (int, list[CollateralCurrencyRes], Configuration) -> None
        """CollateralAdjustRes - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._order_id = None
        self._collateral_currencies = None
        self.discriminator = None

        if order_id is not None:
            self.order_id = order_id
        if collateral_currencies is not None:
            self.collateral_currencies = collateral_currencies

    @property
    def order_id(self):
        """Gets the order_id of this CollateralAdjustRes.  # noqa: E501

        Order ID  # noqa: E501

        :return: The order_id of this CollateralAdjustRes.  # noqa: E501
        :rtype: int
        """
        return self._order_id

    @order_id.setter
    def order_id(self, order_id):
        """Sets the order_id of this CollateralAdjustRes.

        Order ID  # noqa: E501

        :param order_id: The order_id of this CollateralAdjustRes.  # noqa: E501
        :type: int
        """

        self._order_id = order_id

    @property
    def collateral_currencies(self):
        """Gets the collateral_currencies of this CollateralAdjustRes.  # noqa: E501

        Collateral Currency Information  # noqa: E501

        :return: The collateral_currencies of this CollateralAdjustRes.  # noqa: E501
        :rtype: list[CollateralCurrencyRes]
        """
        return self._collateral_currencies

    @collateral_currencies.setter
    def collateral_currencies(self, collateral_currencies):
        """Sets the collateral_currencies of this CollateralAdjustRes.

        Collateral Currency Information  # noqa: E501

        :param collateral_currencies: The collateral_currencies of this CollateralAdjustRes.  # noqa: E501
        :type: list[CollateralCurrencyRes]
        """

        self._collateral_currencies = collateral_currencies

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, CollateralAdjustRes):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, CollateralAdjustRes):
            return True

        return self.to_dict() != other.to_dict()
