# coding: utf-8

"""
    Gate API v4

    Welcome to Gate.io API  APIv4 provides spot, margin and futures trading operations. There are public APIs to retrieve the real-time market statistics, and private APIs which needs authentication to trade on user's behalf.  # noqa: E501

    Contact: support@mail.gate.io
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from gate_api.configuration import Configuration


class IndexConstituent(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'exchange': 'str',
        'symbols': 'list[str]'
    }

    attribute_map = {
        'exchange': 'exchange',
        'symbols': 'symbols'
    }

    def __init__(self, exchange=None, symbols=None, local_vars_configuration=None):  # noqa: E501
        # type: (str, list[str], Configuration) -> None
        """IndexConstituent - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._exchange = None
        self._symbols = None
        self.discriminator = None

        if exchange is not None:
            self.exchange = exchange
        if symbols is not None:
            self.symbols = symbols

    @property
    def exchange(self):
        """Gets the exchange of this IndexConstituent.  # noqa: E501

        Exchange  # noqa: E501

        :return: The exchange of this IndexConstituent.  # noqa: E501
        :rtype: str
        """
        return self._exchange

    @exchange.setter
    def exchange(self, exchange):
        """Sets the exchange of this IndexConstituent.

        Exchange  # noqa: E501

        :param exchange: The exchange of this IndexConstituent.  # noqa: E501
        :type: str
        """

        self._exchange = exchange

    @property
    def symbols(self):
        """Gets the symbols of this IndexConstituent.  # noqa: E501

        Symbol list  # noqa: E501

        :return: The symbols of this IndexConstituent.  # noqa: E501
        :rtype: list[str]
        """
        return self._symbols

    @symbols.setter
    def symbols(self, symbols):
        """Sets the symbols of this IndexConstituent.

        Symbol list  # noqa: E501

        :param symbols: The symbols of this IndexConstituent.  # noqa: E501
        :type: list[str]
        """

        self._symbols = symbols

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, IndexConstituent):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, IndexConstituent):
            return True

        return self.to_dict() != other.to_dict()
