# coding: utf-8

"""
    Gate API v4

    Welcome to Gate.io API  APIv4 provides spot, margin and futures trading operations. There are public APIs to retrieve the real-time market statistics, and private APIs which needs authentication to trade on user's behalf.  # noqa: E501

    Contact: support@mail.gate.io
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from gate_api.configuration import Configuration


class OptionsUnderlying(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'name': 'str',
        'index_price': 'str'
    }

    attribute_map = {
        'name': 'name',
        'index_price': 'index_price'
    }

    def __init__(self, name=None, index_price=None, local_vars_configuration=None):  # noqa: E501
        # type: (str, str, Configuration) -> None
        """OptionsUnderlying - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._name = None
        self._index_price = None
        self.discriminator = None

        if name is not None:
            self.name = name
        if index_price is not None:
            self.index_price = index_price

    @property
    def name(self):
        """Gets the name of this OptionsUnderlying.  # noqa: E501

        Underlying name  # noqa: E501

        :return: The name of this OptionsUnderlying.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this OptionsUnderlying.

        Underlying name  # noqa: E501

        :param name: The name of this OptionsUnderlying.  # noqa: E501
        :type: str
        """

        self._name = name

    @property
    def index_price(self):
        """Gets the index_price of this OptionsUnderlying.  # noqa: E501

        Spot index price (quote currency)  # noqa: E501

        :return: The index_price of this OptionsUnderlying.  # noqa: E501
        :rtype: str
        """
        return self._index_price

    @index_price.setter
    def index_price(self, index_price):
        """Sets the index_price of this OptionsUnderlying.

        Spot index price (quote currency)  # noqa: E501

        :param index_price: The index_price of this OptionsUnderlying.  # noqa: E501
        :type: str
        """

        self._index_price = index_price

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, OptionsUnderlying):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, OptionsUnderlying):
            return True

        return self.to_dict() != other.to_dict()
