# coding: utf-8

"""
    Gate API v4

    Welcome to Gate.io API  APIv4 provides spot, margin and futures trading operations. There are public APIs to retrieve the real-time market statistics, and private APIs which needs authentication to trade on user's behalf.  # noqa: E501

    Contact: support@mail.gate.io
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from gate_api.configuration import Configuration


class SmallBalanceHistory(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'id': 'str',
        'currency': 'str',
        'amount': 'str',
        'gt_amount': 'str',
        'create_time': 'int'
    }

    attribute_map = {
        'id': 'id',
        'currency': 'currency',
        'amount': 'amount',
        'gt_amount': 'gt_amount',
        'create_time': 'create_time'
    }

    def __init__(self, id=None, currency=None, amount=None, gt_amount=None, create_time=None, local_vars_configuration=None):  # noqa: E501
        # type: (str, str, str, str, int, Configuration) -> None
        """SmallBalanceHistory - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._id = None
        self._currency = None
        self._amount = None
        self._gt_amount = None
        self._create_time = None
        self.discriminator = None

        if id is not None:
            self.id = id
        if currency is not None:
            self.currency = currency
        if amount is not None:
            self.amount = amount
        if gt_amount is not None:
            self.gt_amount = gt_amount
        if create_time is not None:
            self.create_time = create_time

    @property
    def id(self):
        """Gets the id of this SmallBalanceHistory.  # noqa: E501

        Order ID  # noqa: E501

        :return: The id of this SmallBalanceHistory.  # noqa: E501
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this SmallBalanceHistory.

        Order ID  # noqa: E501

        :param id: The id of this SmallBalanceHistory.  # noqa: E501
        :type: str
        """

        self._id = id

    @property
    def currency(self):
        """Gets the currency of this SmallBalanceHistory.  # noqa: E501

        Currency  # noqa: E501

        :return: The currency of this SmallBalanceHistory.  # noqa: E501
        :rtype: str
        """
        return self._currency

    @currency.setter
    def currency(self, currency):
        """Sets the currency of this SmallBalanceHistory.

        Currency  # noqa: E501

        :param currency: The currency of this SmallBalanceHistory.  # noqa: E501
        :type: str
        """

        self._currency = currency

    @property
    def amount(self):
        """Gets the amount of this SmallBalanceHistory.  # noqa: E501

        amount  # noqa: E501

        :return: The amount of this SmallBalanceHistory.  # noqa: E501
        :rtype: str
        """
        return self._amount

    @amount.setter
    def amount(self, amount):
        """Sets the amount of this SmallBalanceHistory.

        amount  # noqa: E501

        :param amount: The amount of this SmallBalanceHistory.  # noqa: E501
        :type: str
        """

        self._amount = amount

    @property
    def gt_amount(self):
        """Gets the gt_amount of this SmallBalanceHistory.  # noqa: E501

        GT amount  # noqa: E501

        :return: The gt_amount of this SmallBalanceHistory.  # noqa: E501
        :rtype: str
        """
        return self._gt_amount

    @gt_amount.setter
    def gt_amount(self, gt_amount):
        """Sets the gt_amount of this SmallBalanceHistory.

        GT amount  # noqa: E501

        :param gt_amount: The gt_amount of this SmallBalanceHistory.  # noqa: E501
        :type: str
        """

        self._gt_amount = gt_amount

    @property
    def create_time(self):
        """Gets the create_time of this SmallBalanceHistory.  # noqa: E501

        Exchange time (in seconds)  # noqa: E501

        :return: The create_time of this SmallBalanceHistory.  # noqa: E501
        :rtype: int
        """
        return self._create_time

    @create_time.setter
    def create_time(self, create_time):
        """Sets the create_time of this SmallBalanceHistory.

        Exchange time (in seconds)  # noqa: E501

        :param create_time: The create_time of this SmallBalanceHistory.  # noqa: E501
        :type: int
        """

        self._create_time = create_time

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, SmallBalanceHistory):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, SmallBalanceHistory):
            return True

        return self.to_dict() != other.to_dict()
