# coding: utf-8

"""
    Gate API v4

    Welcome to Gate.io API  APIv4 provides spot, margin and futures trading operations. There are public APIs to retrieve the real-time market statistics, and private APIs which needs authentication to trade on user's behalf.  # noqa: E501

    Contact: support@mail.gate.io
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from gate_api.configuration import Configuration


class UidPushWithdrawal(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'receive_uid': 'int',
        'currency': 'str',
        'amount': 'str'
    }

    attribute_map = {
        'receive_uid': 'receive_uid',
        'currency': 'currency',
        'amount': 'amount'
    }

    def __init__(self, receive_uid=None, currency=None, amount=None, local_vars_configuration=None):  # noqa: E501
        # type: (int, str, str, Configuration) -> None
        """UidPushWithdrawal - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._receive_uid = None
        self._currency = None
        self._amount = None
        self.discriminator = None

        self.receive_uid = receive_uid
        self.currency = currency
        self.amount = amount

    @property
    def receive_uid(self):
        """Gets the receive_uid of this UidPushWithdrawal.  # noqa: E501

        Recipient UID  # noqa: E501

        :return: The receive_uid of this UidPushWithdrawal.  # noqa: E501
        :rtype: int
        """
        return self._receive_uid

    @receive_uid.setter
    def receive_uid(self, receive_uid):
        """Sets the receive_uid of this UidPushWithdrawal.

        Recipient UID  # noqa: E501

        :param receive_uid: The receive_uid of this UidPushWithdrawal.  # noqa: E501
        :type: int
        """
        if self.local_vars_configuration.client_side_validation and receive_uid is None:  # noqa: E501
            raise ValueError("Invalid value for `receive_uid`, must not be `None`")  # noqa: E501

        self._receive_uid = receive_uid

    @property
    def currency(self):
        """Gets the currency of this UidPushWithdrawal.  # noqa: E501

        Currency name  # noqa: E501

        :return: The currency of this UidPushWithdrawal.  # noqa: E501
        :rtype: str
        """
        return self._currency

    @currency.setter
    def currency(self, currency):
        """Sets the currency of this UidPushWithdrawal.

        Currency name  # noqa: E501

        :param currency: The currency of this UidPushWithdrawal.  # noqa: E501
        :type: str
        """
        if self.local_vars_configuration.client_side_validation and currency is None:  # noqa: E501
            raise ValueError("Invalid value for `currency`, must not be `None`")  # noqa: E501

        self._currency = currency

    @property
    def amount(self):
        """Gets the amount of this UidPushWithdrawal.  # noqa: E501

        Transfer amount  # noqa: E501

        :return: The amount of this UidPushWithdrawal.  # noqa: E501
        :rtype: str
        """
        return self._amount

    @amount.setter
    def amount(self, amount):
        """Sets the amount of this UidPushWithdrawal.

        Transfer amount  # noqa: E501

        :param amount: The amount of this UidPushWithdrawal.  # noqa: E501
        :type: str
        """
        if self.local_vars_configuration.client_side_validation and amount is None:  # noqa: E501
            raise ValueError("Invalid value for `amount`, must not be `None`")  # noqa: E501

        self._amount = amount

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, UidPushWithdrawal):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, UidPushWithdrawal):
            return True

        return self.to_dict() != other.to_dict()
